package com.sibatel.solarapp.adapter

import android.content.Intent
import android.net.Uri
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.sibatel.solarapp.data.model.user.User
import com.sibatel.solarapp.databinding.ListProfilBinding

class UserAdapter(var listUser : ArrayList<User>?) : RecyclerView.Adapter<UserAdapter.UserViewHolder>() {

    inner class UserViewHolder(private val binding : ListProfilBinding) : RecyclerView.ViewHolder(binding.root){
        val nama = binding.userNama
        val status = binding.userStatus
        val wa = binding.userWhatsapp
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): UserViewHolder {
        val view = ListProfilBinding.inflate(LayoutInflater.from(parent.context), parent, false)
        return UserViewHolder(view)
    }

    override fun onBindViewHolder(holder: UserViewHolder, position: Int) {
        holder.nama.text = listUser?.get(position)?.nama
        holder.status.text = listUser?.get(position)?.role
        var cek = listUser?.get(position)?.noHp?.substring(0,1)
        var inWa = "0"
        if (cek.equals("0")){
            inWa = "https://api.whatsapp.com/send?phone=+62"+listUser?.get(position)?.noHp;
        }else{
            inWa = "https://api.whatsapp.com/send?phone="+listUser?.get(position)?.noHp;
        }

        holder.wa.setOnClickListener{
            val intent = Intent(Intent.ACTION_VIEW)
            intent.setData(Uri.parse(inWa))
            it.context.startActivity(intent)
        }

    }

    override fun getItemCount(): Int {
        return listUser?.size ?: 0
    }

}