package com.sibatel.solarapp.ui.mentoring.solar.pengambilan

import android.app.AlertDialog
import android.app.DatePickerDialog
import android.app.DatePickerDialog.OnDateSetListener
import android.content.DialogInterface
import android.content.Intent
import android.database.Cursor
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.text.Editable
import android.text.TextWatcher
import android.util.Base64
import android.util.Log
import android.view.Menu
import android.view.MenuItem
import android.view.View
import android.widget.*
import androidx.annotation.NonNull
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.FileProvider
import com.sibatel.solarapp.R
import com.sibatel.solarapp.data.model.solar.pengambilansolar.PengambilanSolarResponse
import com.sibatel.solarapp.data.model.tower.TowerResponse
import com.sibatel.solarapp.databinding.ActivityMenuPengambilanSolarBinding
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.ui.LoginActivity
import com.sibatel.solarapp.ui.mentoring.MentoringSolar
import com.sibatel.solarapp.ui.user.Profil
import com.sibatel.solarapp.utils.SharedPref
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.io.*
import java.util.*
import kotlin.collections.ArrayList


class MenuPengambilanSolar : AppCompatActivity() {

    private lateinit var menuBinding : ActivityMenuPengambilanSolarBinding
    private var cekUp: Int = 0
    private var Document_img1: String = ""
    private lateinit var bitmap1 : Bitmap
    private lateinit var bitmap2 : Bitmap
    private lateinit var bitmap3 : Bitmap
    private lateinit var bitmap4 : Bitmap
    private lateinit var sharedPref: SharedPref
    private lateinit var site:Spinner
    private lateinit var tujuanSite: Spinner
    var img1 =""
    var img2 =""
    var img3 =""
    var img4 =""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        menuBinding = ActivityMenuPengambilanSolarBinding.inflate(layoutInflater)
        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        setContentView(menuBinding.root)
        supportActionBar?.title = "Pengambilan Solar"
        supportActionBar?.setDisplayShowHomeEnabled(true)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        showLoading(true)
        var allTower = ArrayList<String>()
        allTower.add("Pilih Site")
        sharedPref = SharedPref(this)

        println("Role     : "+sharedPref.getSite1())
        RetrofitClient.apiInstance.getAllTower().enqueue(object : Callback<TowerResponse>{
            override fun onResponse(call: Call<TowerResponse>, response: Response<TowerResponse>) {
                if (response.isSuccessful){
                    response.body()?.result?.forEach {
                        println(it?.clusterTower+"  "+sharedPref.getSite1())
                        if (it?.clusterTower.equals(sharedPref.getSite1())){
                            it?.namaTower?.let { it1 -> allTower.add(it1) }
                        }
                    }
                }
            }

            override fun onFailure(call: Call<TowerResponse>, t: Throwable) {

            }

        })



        menuBinding.txtName.text = sharedPref.getRole1()+"-"+sharedPref.getNama1()

        var tanggal = ""

        if (sharedPref.getRole1().equals("timkorektif")){
            menuBinding.layoutMore.visibility = View.GONE
        }

        RetrofitClient.apiInstance.cekPengambilanSolar(sharedPref.getId())
            .enqueue(object : Callback<PengambilanSolarResponse>{
                override fun onResponse(
                    call: Call<PengambilanSolarResponse>,
                    response: Response<PengambilanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        if (response?.body()?.result?.size!! > 0){
                            val intent = Intent(this@MenuPengambilanSolar, PengambilanSolarLjtn::class.java)
                            showLoading(false)
                            startActivity(intent)
                            finish()
                        }else{
                            showLoading(false)
                        }
                    }
                }

                override fun onFailure(call: Call<PengambilanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                }

            })

        menuBinding.dateSolarTaken.setOnClickListener {
            val cldr: Calendar = Calendar.getInstance()
            val day: Int = cldr.get(Calendar.DAY_OF_MONTH)
            val month: Int = cldr.get(Calendar.MONTH)
            val year: Int = cldr.get(Calendar.YEAR)
            var bulan = ""
            var hari = ""

            val picker = DatePickerDialog(
                this,
                { view, year, monthOfYear, dayOfMonth ->
                    if(monthOfYear + 1<10){
                        bulan = "0"+(monthOfYear + 1)
                    }else{
                        bulan = (monthOfYear + 1).toString()
                    }

                    if(dayOfMonth<10){
                        hari = "0"+dayOfMonth
                    }else{
                        hari = dayOfMonth.toString()
                    }
                    menuBinding.dateSolarTaken.setText(
                        year.toString() + "-" + bulan + "-" + hari
                    )
                    tanggal =  menuBinding.dateSolarTaken.text.toString()
                },
                year,
                month,
                day
            )
            picker.show()
        }

        var jlhPendonorSdh = ""
        var jlhSlrGsSdh = ""

        menuBinding.jlhSolar.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (menuBinding.solarDiambil.text.isNotEmpty() && menuBinding.jlhSolar.text.isNotEmpty()){
                    var hasil = (p0.toString().toInt() - menuBinding.solarDiambil.text.toString().toInt())
                    menuBinding.sisaSolarPendonor.setText(hasil.toString())
                    jlhPendonorSdh = hasil.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        menuBinding.solarDiambil.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (menuBinding.jlhSolar.text.isNotEmpty()&&menuBinding.solarDiambil.text.isNotEmpty()){
                    var hasil = ( menuBinding.jlhSolar.text.toString().toInt()-p0.toString().toInt())
                    menuBinding.sisaSolarPendonor.setText(hasil.toString())
                    jlhPendonorSdh = hasil.toString()
                }

                if (menuBinding.solarDiambil.text.isNotEmpty()&&menuBinding.bbmDimobilSebelum.text.isNotEmpty()){
                    var bbmSesudah = menuBinding.bbmDimobilSebelum.text.toString().toInt()+p0.toString().toInt()

                    menuBinding.bbmDimobilSesudah.setText(bbmSesudah.toString())
                    jlhSlrGsSdh = bbmSesudah.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }
        })

        menuBinding.bbmDimobilSebelum.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (menuBinding.bbmDimobilSebelum.text.isNotEmpty()&&menuBinding.solarDiambil.text.isNotEmpty()){
                    var bbmSesudah = menuBinding.solarDiambil.text.toString().toInt()+p0.toString().toInt()

                    menuBinding.bbmDimobilSesudah.setText(bbmSesudah.toString())
                    jlhSlrGsSdh = bbmSesudah.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        var dariSite = ""
        var tujuanSitetxt = ""
        var jenisGenset = "0"
        val jlhPendonorSblm = menuBinding.jlhSolar.text
        val jlhSolarDiambil = menuBinding.solarDiambil.text
        val jlhSlrGsSblm = menuBinding.bbmDimobilSebelum.text
        val saksi = menuBinding.saksi.text
        val userId = sharedPref.getId()




        if (sharedPref.getRole1().equals("scd")){
            menuBinding.tujuanSite.visibility = View.GONE
            menuBinding.txtSite.visibility = View.GONE
            tujuanSitetxt = "null"
        }

        site = menuBinding.site
        tujuanSite = menuBinding.tujuanSite


        //set Adapter
        val adapter = ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, allTower)
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        site.adapter = adapter
        tujuanSite.adapter = adapter

        site.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 ==  0){
                    dariSite = ""
                }else{
                    val number = p0?.getItemAtPosition(p2).toString()
                    dariSite = number
                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }

        tujuanSite.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 == 0){
                    tujuanSitetxt = ""
                }else{
                    val number = p0?.getItemAtPosition(p2).toString()
                    tujuanSitetxt = number
                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }


        menuBinding.btnSolarTerakhir.setOnClickListener {
            cekUp = 1
            selectImage();
        }

        menuBinding.btnSisaSolarPendonor.setOnClickListener{
            cekUp = 2
            selectImage()
        }

        menuBinding.btnBbmMobilSebelum.setOnClickListener{
            cekUp = 3
            selectImage()
        }

        menuBinding.btnBbmMobilSetelah.setOnClickListener{
            cekUp = 4
            selectImage()
        }

        menuBinding.btnKirimPengambilan.setOnClickListener{
            if (sharedPref.getRole1().equals("timkorektif")){
                if(tanggal.isEmpty()){
                    menuBinding.dateSolarTaken.error = "Anda harus memilih tanggal"
                }else if (dariSite.length == 0){
                    (site.selectedView as TextView).error = "Anda harus memilih Site ini"
                }else if(tujuanSite.toString().length == 0){
                    (tujuanSite.selectedView as TextView).error = "Anda harus memilih Site ini"
                }else if(jenisGenset.length == 0){

                }else if(jlhPendonorSblm.toString().length == 0){
                    menuBinding.jlhSolar.error = "Field ini harus diisi"
                }else if(img1.isEmpty()){
                    menuBinding.btnSolarTerakhir.error = "Anda harus mengisi gambar ini"
                }else if(jlhSolarDiambil.toString().length == 0){
                    menuBinding.solarDiambil.error = "Field ini harus diisi"
                }else if(jlhPendonorSdh.toString().length == 0){
                    menuBinding.sisaSolarPendonor.error = "Field ini harus diisi"
                }else if(img2.isEmpty()){
                    menuBinding.btnSisaSolarPendonor.error = "Anda harus mengisi gambar ini"
                }else{
                    menuBinding.btnKirimPengambilan.startAnimation()
                    addData(tanggal ,dariSite, tujuanSitetxt, jenisGenset , jlhPendonorSblm.toString(),
                        jlhSolarDiambil.toString(), jlhPendonorSdh, "0", "0",
                        saksi.toString(), userId.toString())
                }
            }else{
                if(tanggal.isEmpty()){
                    menuBinding.dateSolarTaken.error = "Anda harus memilih tanggal"
                }else if (dariSite.length == 0){
                    (site.selectedView as TextView).error = "Anda harus memilih Site ini"
                }else if(tujuanSite.toString().length == 0){
                    (tujuanSite.selectedView as TextView).error = "Anda harus memilih Site ini"
                }else if(jenisGenset.length == 0){

                }else if(jlhPendonorSblm.toString().length == 0){
                    menuBinding.jlhSolar.error = "Field ini harus diisi"
                }else if(img1.isEmpty()){
                    menuBinding.btnSolarTerakhir.error = "Anda harus mengisi gambar ini"
                }else if(jlhSolarDiambil.toString().length == 0){
                    menuBinding.solarDiambil.error = "Field ini harus diisi"
                }else if(jlhPendonorSdh.length == 0){
                    menuBinding.sisaSolarPendonor.error = "Field ini harus diisi"
                }else if(img2.isEmpty()){
                    menuBinding.btnSisaSolarPendonor.error = "Anda harus mengisi gambar ini"
                }else if(jlhSlrGsSblm.toString().length == 0){
                    menuBinding.bbmDimobilSebelum.error = "Field ini harus diisi"
                }else if(img3.isEmpty()){
                    menuBinding.btnBbmMobilSebelum.error = "Anda harus mengisi gambar ini"
                }else if(jlhSlrGsSdh.length == 0){
                    menuBinding.bbmDimobilSesudah.error = "Field ini harus diisi"
                }else if(img4.isEmpty()){
                    menuBinding.btnBbmMobilSetelah.error = "Anda harus mengisi gambar ini"
                }else{
                    menuBinding.btnKirimPengambilan.startAnimation()
                    addData(tanggal ,dariSite.toString(), tujuanSitetxt.toString(), jenisGenset.toString(), jlhPendonorSblm.toString(),
                        jlhSolarDiambil.toString(), jlhPendonorSdh.toString(), jlhSlrGsSblm.toString(), jlhSlrGsSdh.toString(),
                        saksi.toString(), userId.toString())
                }
            }


        }
    }


    private fun selectImage() {
        val options = arrayOf<CharSequence>("Take Photo", "Choose from Gallery", "Cancel")
        val builder = AlertDialog.Builder(this)
        builder.setTitle("Add Photo!")
        builder.setItems(options, DialogInterface.OnClickListener { dialog, item ->
            if (options[item] == "Take Photo") {
                val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                val f = File(Environment.getExternalStorageDirectory(), "temp.jpg")
                intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                val photoURI =  FileProvider.getUriForFile(this, this.getApplicationContext().getPackageName() + ".provider", f)
                intent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI)
                startActivityForResult(intent, 1)
            } else if (options[item] == "Choose from Gallery") {
                val intent =
                    Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI)
                startActivityForResult(intent, 2)
            } else if (options[item] == "Cancel") {
                dialog.dismiss()
            }
        })
        builder.show()
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK){
            if (requestCode == 1){
                var f = File(Environment.getExternalStorageDirectory().toString())
                for (temp in f.listFiles()) {
                    if (temp.name == "temp.jpg") {
                        f = temp
                        break
                    }
                }
                try {
                    val bitmapOptions = BitmapFactory.Options()
                    if (cekUp == 1){
                        bitmap1 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap1 = getResizedBitmap(bitmap1, 400)
                        menuBinding.imgSolarTerakhir.setImageBitmap(bitmap1)
                        BitMapToString(bitmap1)
                    }else if (cekUp == 2){
                        bitmap2 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap2 = getResizedBitmap(bitmap2, 400)
                        menuBinding.imgSisaSolarPendonor.setImageBitmap(bitmap2)
                        BitMapToString(bitmap2)
                    }else if(cekUp == 3){
                        bitmap3 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap3 = getResizedBitmap(bitmap3, 400)
                        menuBinding.imgBbmMobilSebelum.setImageBitmap(bitmap3)
                    }else if (cekUp == 4){
                        bitmap4 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                        bitmap4 = getResizedBitmap(bitmap4, 400)
                        menuBinding.imgBbmMobilSetelah.setImageBitmap(bitmap4)
                    }


                    val path = (Environment
                        .getExternalStorageDirectory()
                        .toString() + File.separator
                            + "Phoenix" + File.separator + "default")
                    f.delete()
                    var outFile: OutputStream? = null
                    val file = File(path, System.currentTimeMillis().toString() + ".jpg")
                    if (cekUp==1){
                        menuBinding.btnSolarTerakhir.text = file.name.toString().toEditable()
                        img1 = menuBinding.btnSolarTerakhir.text.toString()
                    }else if (cekUp==2){
                        menuBinding.btnSisaSolarPendonor.text = file.name.toString().toEditable()
                        img2 = menuBinding.btnSolarTerakhir.text.toString()
                    }else if (cekUp==3){
                        menuBinding.btnBbmMobilSebelum.text = file.name.toString().toEditable()
                        img3 = menuBinding.btnSolarTerakhir.text.toString()
                    }else if(cekUp==4){
                        menuBinding.btnBbmMobilSetelah.text = file.name.toString().toEditable()
                        img4 = menuBinding.btnSolarTerakhir.text.toString()
                    }
                    try {
                        outFile = FileOutputStream(file)
                        if (cekUp==1){
                            bitmap1.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if (cekUp==2){
                            bitmap2.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if (cekUp==3){
                            bitmap3.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }else if(cekUp==4){
                            bitmap4.compress(Bitmap.CompressFormat.JPEG, 70, outFile)
                        }
                        outFile.flush()
                        outFile.close()
                    } catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }else if (requestCode == 2) {
                val selectedImage = data?.data
                val filePathColumn = arrayOf(MediaStore.Images.Media.DATA)
                val cursor: Cursor? = contentResolver.query(
                    selectedImage!!,
                    filePathColumn, null, null, null
                )
                cursor?.moveToFirst()
                val columnIndex: Int = cursor!!.getColumnIndex(filePathColumn[0])
                val picturePath: String = cursor.getString(columnIndex)
                val imgNama = File(picturePath)
                try {
                    if (cekUp == 1){
                        bitmap1 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap1 = getResizedBitmap(bitmap1, 400)
                        menuBinding.imgSolarTerakhir.setImageBitmap(bitmap1)
                        menuBinding.btnSolarTerakhir.text = imgNama.name.toString().toEditable()
                        img1 = menuBinding.btnSolarTerakhir.text.toString()
                    }else if (cekUp == 2){
                        bitmap2 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap2 = getResizedBitmap(bitmap2, 400)
                        menuBinding.imgSisaSolarPendonor.setImageBitmap(bitmap2)
                        menuBinding.btnSisaSolarPendonor.text = imgNama.name.toString().toEditable()
                        img2 = menuBinding.btnSisaSolarPendonor.text.toString()
                    }else if(cekUp == 3){
                        bitmap3 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap3 = getResizedBitmap(bitmap3, 400)
                        menuBinding.imgBbmMobilSebelum.setImageBitmap(bitmap3)
                        menuBinding.btnBbmMobilSebelum.text = imgNama.name.toString().toEditable()
                        img3 = menuBinding.btnBbmMobilSebelum.text.toString()
                    }else if (cekUp == 4){
                        bitmap4 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                        bitmap4 = getResizedBitmap(bitmap4, 400)
                        menuBinding.imgBbmMobilSetelah.setImageBitmap(bitmap4)
                        menuBinding.btnBbmMobilSetelah.text = imgNama.name.toString().toEditable()
                        img4 = menuBinding.btnBbmMobilSetelah.text.toString()
                    }
                    var outFile: OutputStream? = null
                    try{
                        outFile = FileOutputStream(imgNama)
                        if (cekUp == 1){
                            bitmap1.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }else if (cekUp == 2){
                            bitmap2.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }else if(cekUp == 3){
                            bitmap3.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }else if (cekUp == 4){
                            bitmap4.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        }
                        outFile.flush()
                        outFile.close()

                    }catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: IOException) {
                    e.printStackTrace()
                }



            }
        }
    }



    fun BitMapToString(userImage1: Bitmap): String? {
        val baos = ByteArrayOutputStream()
        userImage1.compress(Bitmap.CompressFormat.PNG, 60, baos)
        val b = baos.toByteArray()
        Document_img1 = Base64.encodeToString(b, Base64.DEFAULT)
        return Document_img1
    }
    fun getResizedBitmap(image: Bitmap, maxSize: Int): Bitmap {
        var width = image.width
        var height = image.height
        val bitmapRatio = width.toFloat() / height.toFloat()
        if (bitmapRatio > 1) {
            width = maxSize
            height = (width / bitmapRatio).toInt()
        } else {
            height = maxSize
            width = (height * bitmapRatio).toInt()
        }
        return Bitmap.createScaledBitmap(image, width, height, true)
    }

    fun addData(tanggal:String, dariSite:String, tujuanSite:String, jenisGenset:String, jlhPendonorSblm:String, jlhSolarDiambil:String, jlhPendonorSdh:String, jlhSlrGsSblm:String, jlhSlrGsSdh:String, saksi:String, userId:String){
        if (menuBinding.btnSolarTerakhir.text.toString().length ==0){
            menuBinding.btnSolarTerakhir.error = "Ambil gambar terlebih dahulu"
            menuBinding.btnKirimPengambilan.revertAnimation()
        }else{

        }
        val map = HashMap<String, RequestBody>()
        map.put("tanggal", createFormatString(tanggal))
        map.put("dari_site", createFormatString(dariSite))
        map.put("tujuan_site", createFormatString(tujuanSite))
        map.put("jenis_genset", createFormatString(jenisGenset))
        map.put("jlh_pendonor_sblm", createFormatString(jlhPendonorSblm))
        map.put("jlh_solar_diambil", createFormatString(jlhSolarDiambil))
        map.put("jlh_pendonor_sdh", createFormatString(jlhPendonorSdh))
        map.put("jlh_slr_gs_sblm", createFormatString(jlhSlrGsSblm))
        map.put("jlh_slr_gs_sdh", createFormatString(jlhSlrGsSdh))
        map.put("saksi", createFormatString(saksi))
        map.put("user_id", createFormatString(userId))


        var file1: File? = null
        var file2: File? = null
        var file3: File? = null
        var file4: File? = null
        var gmbr1: MultipartBody.Part? = null
        var gmbr2: MultipartBody.Part? = null
        var gmbr3: MultipartBody.Part? = null
        var gmbr4: MultipartBody.Part? = null
        if (sharedPref.getRole1().equals("timkorektif")){
            if(bitmap1 == null && bitmap2 == null){
                file1 = null
                file2 = null
                gmbr1 = null
                gmbr2 = null
            }else{
                file1 = createTempFile(bitmap1!!)
                val reqFile1 = RequestBody.create(MediaType.parse("image/*"), file1)
                gmbr1 = MultipartBody.Part.createFormData("gbr_sp_sblm", file1.name, reqFile1)

                file2 = createTempFile(bitmap2!!)
                val reqFile2 = RequestBody.create(MediaType.parse("image/*"), file2)
                gmbr2 = MultipartBody.Part.createFormData("gbr_sp_sdh", file2.name, reqFile2)
            }
        }else{
            if(bitmap1 == null && bitmap2 == null && bitmap3 == null && bitmap4 == null){
                file1 = null
                file2 = null
                file3 = null
                file4 = null
                gmbr1 = null
                gmbr2 = null
                gmbr3 = null
                gmbr4 = null
            }else{
                file1 = createTempFile(bitmap1!!)
                val reqFile1 = RequestBody.create(MediaType.parse("image/*"), file1)
                gmbr1 = MultipartBody.Part.createFormData("gbr_sp_sblm", file1.name, reqFile1)

                file2 = createTempFile(bitmap2!!)
                val reqFile2 = RequestBody.create(MediaType.parse("image/*"), file2)
                gmbr2 = MultipartBody.Part.createFormData("gbr_sp_sdh", file2.name, reqFile2)

                file3 = createTempFile(bitmap3!!)
                val reqFile3 = RequestBody.create(MediaType.parse("image/*"), file3)
                gmbr3 = MultipartBody.Part.createFormData("gbr_gs_sblm", file3.name, reqFile3)

                file4 = createTempFile(bitmap4!!)
                val reqFile4 = RequestBody.create(MediaType.parse("image/*"), file4)
                gmbr4 = MultipartBody.Part.createFormData("gbr_gs_sdh", file4.name, reqFile4)

            }
        }



        RetrofitClient.apiInstance.addPengambilanSolar(gmbr1, gmbr2, gmbr3, gmbr4 , map)
            .enqueue(object : Callback<PengambilanSolarResponse> {
                override fun onResponse(
                    call: Call<PengambilanSolarResponse>,
                    response: Response<PengambilanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        menuBinding.btnKirimPengambilan.revertAnimation()
                        Toast.makeText(getApplicationContext(), response.body()?.message, Toast.LENGTH_LONG).show()

                        if (sharedPref.getRole1().equals("timkorektif")){
                            val intent = Intent(this@MenuPengambilanSolar, PengambilanSolarLjtn::class.java)
                            startActivity(intent)
                        }else{
                            val intent = Intent(this@MenuPengambilanSolar, MentoringSolar::class.java)
                            startActivity(intent)
                        }

                        finish()
                    }else{
                        Toast.makeText(getApplicationContext(), response.message() ,
                            Toast.LENGTH_LONG).show()
                        menuBinding.btnKirimPengambilan.revertAnimation()
                    }
                }

                override fun onFailure(call: Call<PengambilanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                    menuBinding.btnKirimPengambilan.revertAnimation()
                }

            })

    }

    fun createTempFile(bitmap: Bitmap):File{
        var file  = File(getExternalFilesDir(Environment.DIRECTORY_PICTURES),
            System.currentTimeMillis().toString()+"_image.PNG")
        var bos = ByteArrayOutputStream()

        bitmap.compress(Bitmap.CompressFormat.PNG,0, bos)
        var bitmapData = bos.toByteArray()

        try {
            var fos =  FileOutputStream(file)
            fos.write(bitmapData)
            fos.flush()
            fos.close()
        } catch (e:IOException) {
            e.printStackTrace()
        }
        return file;

        println(file.toString())
    }

    @NonNull
    fun createFormatString(descriptionString:String):RequestBody  {
        return RequestBody.create(
            MultipartBody.FORM, descriptionString);
    }


    fun String.toEditable(): Editable =  Editable.Factory.getInstance().newEditable(this)

    private fun showLoading(state: Boolean) {
        if (state)
            menuBinding.progress.visibility = View.VISIBLE
        else
            menuBinding.progress.visibility = View.GONE
    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        return when (item.itemId) {
            R.id.action_profil -> {
                val intent = Intent(this, Profil::class.java)
                startActivity(intent)
                return true
            }
            R.id.action_logout ->{
                sharedPref.logout()
                val intent = Intent(this, LoginActivity::class.java)
                startActivity(intent)
                finish()
                return true
            }
            else -> super.onOptionsItemSelected(item)
        }
    }
}
