package com.sibatel.solarapp.ui.mentoring.solar.penggunaan

import android.R
import android.app.AlertDialog
import android.app.DatePickerDialog
import android.content.DialogInterface
import android.content.Intent
import android.database.Cursor
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.text.Editable
import android.text.TextWatcher
import android.util.Base64
import android.util.Log
import android.view.View
import android.widget.*
import androidx.annotation.NonNull
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.FileProvider
import com.sibatel.solarapp.data.model.genset.GensetResponse
import com.sibatel.solarapp.data.model.solar.penggunaansolar.PenggunaanSolarResponse
import com.sibatel.solarapp.data.model.tower.TowerResponse
import com.sibatel.solarapp.databinding.ActivityPenggunaanSolarMtcBinding
import com.sibatel.solarapp.network.RetrofitClient
import com.sibatel.solarapp.ui.mentoring.MentoringSolar
import com.sibatel.solarapp.utils.SharedPref
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.io.*
import java.util.*

class PenggunaanSolarMTC: AppCompatActivity()  {
    private lateinit var binding : ActivityPenggunaanSolarMtcBinding
    private var Document_img1: String = ""
    private lateinit var bitmap1 : Bitmap
    private lateinit var site: Spinner
    private lateinit var sharedPref: SharedPref
    var img = ""


    override fun onCreate(savedInstanceState: Bundle?){
        super.onCreate(savedInstanceState)
        binding = ActivityPenggunaanSolarMtcBinding.inflate(layoutInflater)
        supportActionBar?.elevation = 0f
        supportActionBar?.setDisplayHomeAsUpEnabled(true)
        setContentView(binding.root)
        supportActionBar?.title = "Penggunaan Solar"
        supportActionBar?.setDisplayShowHomeEnabled(true)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        sharedPref = SharedPref(this)

        var kva = 0.0
        var jenisGenset = ""
        var hmAwal = binding.hmAwal.text
        var hmAkhir = binding.hmAkhir.text
        var totalHm = ""
        var tanggal = ""
        var tujuanSite = ""
        var totalLiter = ""

        binding.user.text = sharedPref.getRole1()+"-"+sharedPref.getNama1()

        var allGenset = ArrayList<String>()
        allGenset.add("Pilih Genset")

        RetrofitClient.apiInstance.getAllGenset()
            .enqueue(object : Callback<GensetResponse>{
                override fun onResponse(
                    call: Call<GensetResponse>,
                    response: Response<GensetResponse>
                ) {
                    if (response.isSuccessful){
                        response.body()?.result?.forEach {
                            it.namaGenset?.let { it1 -> allGenset.add(it1) }
                        }
                    }
                }

                override fun onFailure(call: Call<GensetResponse>, t: Throwable) {
                }

            })

        RetrofitClient.apiInstance.getAllGenset()
            .enqueue(object : Callback<GensetResponse>{
                override fun onResponse(
                    call: Call<GensetResponse>,
                    response: Response<GensetResponse>
                ) {
                    if (response.isSuccessful){
                        response.body()?.result?.forEach {
                            if (it?.namaGenset.equals(jenisGenset)){
                                kva = it?.debit.toString().toDouble()
                                if (binding.totalHm.text.isNotEmpty()){
                                    var ttlPenggunaan = kva*binding.totalHm.text.toString().toDouble()
                                    binding.penggunaanSolar.setText(String.format("%.0f", ttlPenggunaan.toString().toDouble()))
                                    totalLiter = ttlPenggunaan.toString()
                                }
                            }
                        }
                    }
                }

                override fun onFailure(call: Call<GensetResponse>, t: Throwable) {
                }

            })

        val adapter2 = ArrayAdapter<String>(this, R.layout.simple_spinner_dropdown_item, allGenset)
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        binding.jenisGenset.adapter = adapter2

        binding.jenisGenset.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 == 0){
                    jenisGenset = ""
                }else{
                    if (p2 == 0){
                        jenisGenset = ""
                    }else{
                        val number = p0?.getItemAtPosition(p2).toString()
                        jenisGenset = number
                        RetrofitClient.apiInstance.getAllGenset()
                            .enqueue(object : Callback<GensetResponse>{
                                override fun onResponse(
                                    call: Call<GensetResponse>,
                                    response: Response<GensetResponse>
                                ) {
                                    if (response.isSuccessful){
                                        response.body()?.result?.forEach {
                                            if (it?.namaGenset.equals(jenisGenset.toString())){
                                                kva = it?.debit.toString().toDouble()
                                                if (binding.totalHm.text.isNotEmpty()){
                                                    var ttlPenggunaan = kva*binding.totalHm.text.toString().toDouble()
                                                    binding.penggunaanSolar.setText(String.format("%.0f", ttlPenggunaan.toString().toDouble()))
                                                    totalLiter = ttlPenggunaan.toString()
                                                }
                                            }
                                        }
                                    }
                                }

                                override fun onFailure(call: Call<GensetResponse>, t: Throwable) {
                                }

                            })
                    }
                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }

        binding.dateSolarTaken.setOnClickListener {
            val cldr: Calendar = Calendar.getInstance()
            val day: Int = cldr.get(Calendar.DAY_OF_MONTH)
            val month: Int = cldr.get(Calendar.MONTH)
            val year: Int = cldr.get(Calendar.YEAR)
            var bulan = ""
            var hari = ""

            val picker = DatePickerDialog(
                this,
                { view, year, monthOfYear, dayOfMonth ->
                    if(monthOfYear + 1<10){
                        bulan = "0"+(monthOfYear + 1)
                    }else{
                        bulan = (monthOfYear + 1).toString()
                    }

                    if(dayOfMonth<10){
                        hari = "0"+dayOfMonth
                    }else{
                        hari = dayOfMonth.toString()
                    }
                    binding.dateSolarTaken.setText(
                        year.toString() + "-" + bulan + "-" + hari
                    )
                    tanggal = binding.dateSolarTaken.text.toString()
                },
                year,
                month,
                day
            )
            picker.show()
        }

        var allTower = ArrayList<String>()
        allTower.add("Pilih Site")

        RetrofitClient.apiInstance.getAllTower().enqueue(object : Callback<TowerResponse> {
            override fun onResponse(call: Call<TowerResponse>, response: Response<TowerResponse>) {
                if (response.isSuccessful){
                    response.body()?.result?.forEach {
                        if(it?.clusterTower.equals(sharedPref.getSite1())){
                            it?.namaTower?.let { it1 -> allTower.add(it1) }
                        }

                    }
                }
            }

            override fun onFailure(call: Call<TowerResponse>, t: Throwable) {

            }

        })
        site = binding.site

        val adapter = ArrayAdapter<String>(this, R.layout.simple_spinner_dropdown_item, allTower)
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        site.adapter = adapter

        site.onItemSelectedListener = object : AdapterView.OnItemSelectedListener{
            override fun onItemSelected(p0: AdapterView<*>?, p1: View?, p2: Int, p3: Long) {
                if (p2 == 0){
                    tujuanSite = ""
                }else{
                    val number = p0?.getItemAtPosition(p2).toString()
                    tujuanSite = number
                }
            }

            override fun onNothingSelected(p0: AdapterView<*>?) {

            }

        }

        binding.hmAkhir.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (binding.hmAkhir.text.isNotEmpty() && binding.hmAwal.text.isNotEmpty()){
                    var hsl = p0.toString().toInt()-binding.hmAwal.text.toString().toInt()
                    binding.totalHm.setText(hsl.toString())
                    totalHm = hsl.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        binding.hmAwal.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (binding.hmAkhir.text.isNotEmpty() && binding.hmAwal.text.isNotEmpty()){
                    var hsl = binding.hmAkhir.text.toString().toInt()-p0.toString().toInt()
                    binding.totalHm.setText(hsl.toString())
                    totalHm = hsl.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        binding.totalHm.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (binding.totalHm.text.isNotEmpty()){
                    var ttlPenggunaan = kva*p0.toString().toDouble()
                    binding.penggunaanSolar.setText(String.format("%.0f", ttlPenggunaan.toString().toDouble()))
                    totalLiter = ttlPenggunaan.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        binding.hmAwal.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                if (binding.hmAkhir.text.isNotEmpty() && binding.hmAwal.text.isNotEmpty()){
                    var hsl = binding.hmAkhir.text.toString().toDouble()-p0.toString().toDouble()
                    binding.totalHm.setText(String.format("%.0f", hsl.toString().toDouble()))
                    totalHm = hsl.toString()
                }
            }

            override fun afterTextChanged(p0: Editable?) {

            }

        })

        binding.btnSolarTerakhir.setOnClickListener{
            selectImage()
        }

        binding.btnKirim.setOnClickListener{
            if(hmAwal.isEmpty()){
                binding.hmAwal.error = "Anda harus mengisi hm awal"
            }else if(hmAkhir.isEmpty() ){
                binding.hmAkhir.error = "Anda harus mengisi hm akhir"
            }else if (img.isEmpty()){
                binding.btnSolarTerakhir.error = "Anda harus memilih gambar terlebih dahulu"
            }else{
                binding.btnKirim.startAnimation()
                kirimData(tanggal,tujuanSite,jenisGenset, hmAwal.toString(),hmAkhir.toString(), totalHm, totalLiter)
            }
        }

    }

    fun kirimData(tanggal:String, tujuanSite:String,jenisGenset:String
                  ,hmAwal:String, hmaAkhir:String, totalHm:String, totalLiter:String,){
        val map = HashMap<String, RequestBody>()
        map.put("tanggal", createFormatString(tanggal))
        map.put("tujuan_site", createFormatString(tujuanSite))
        map.put("jenis_genset", createFormatString(jenisGenset))
        map.put("hm_awal", createFormatString(hmAwal))
        map.put("hm_akhir", createFormatString(hmaAkhir))
        map.put("total_liter", createFormatString(totalLiter))
        map.put("user_id", createFormatString(sharedPref.getId().toString()))
        map.put("total_hm", createFormatString(totalHm))

        var file1: File? = null
        var gmbr1: MultipartBody.Part? = null
        if(bitmap1 == null){
            file1 = null
            gmbr1 = null
        }else{
            file1 = createTempFile(bitmap1!!)
            val reqFile1 = RequestBody.create(MediaType.parse("image/*"), file1)
            gmbr1 = MultipartBody.Part.createFormData("gbr_hmakhir", file1.name, reqFile1)
        }

        RetrofitClient.apiInstance.addPenggunaanSolar(gmbr1, map)
            .enqueue(object : Callback<PenggunaanSolarResponse>{
                override fun onResponse(
                    call: Call<PenggunaanSolarResponse>,
                    response: Response<PenggunaanSolarResponse>
                ) {
                    if (response.isSuccessful){
                        Toast.makeText(applicationContext, response.body()?.message, Toast.LENGTH_LONG).show()

                        val intent = Intent(this@PenggunaanSolarMTC, MentoringSolar::class.java)
                        startActivity(intent)
                        finish()

                        binding.btnKirim.revertAnimation()
                    }else{
                        Toast.makeText(
                            applicationContext, response.message() ,
                            Toast.LENGTH_LONG).show();
                        binding.btnKirim.revertAnimation()
                    }
                }

                override fun onFailure(call: Call<PenggunaanSolarResponse>, t: Throwable) {
                    t.message?.let { Log.d("error Server", it) }
                    binding.btnKirim.revertAnimation()
                }

            })
    }

    private fun selectImage() {
        val options = arrayOf<CharSequence>("Take Photo", "Choose from Gallery", "Cancel")
        val builder = AlertDialog.Builder(this)
        builder.setTitle("Add Photo!")
        builder.setItems(options, DialogInterface.OnClickListener { dialog, item ->
            if (options[item] == "Take Photo") {
                val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
                val f = File(Environment.getExternalStorageDirectory(), "temp.jpg")
                intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
                val photoURI =  FileProvider.getUriForFile(this, this.getApplicationContext().getPackageName() + ".provider", f)
                intent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI)
                startActivityForResult(intent, 1)
            } else if (options[item] == "Choose from Gallery") {
                val intent =
                    Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI)
                startActivityForResult(intent, 2)
            } else if (options[item] == "Cancel") {
                dialog.dismiss()
            }
        })
        builder.show()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK){
            if (requestCode == 1){
                var f = File(Environment.getExternalStorageDirectory().toString())
                for (temp in f.listFiles()) {
                    if (temp.name == "temp.jpg") {
                        f = temp
                        break
                    }
                }
                try {
                    val bitmapOptions = BitmapFactory.Options()

                    bitmap1 = BitmapFactory.decodeFile(f.absolutePath, bitmapOptions)
                    bitmap1 = getResizedBitmap(bitmap1, 400)
                    binding.imgSolarTerakhir.setImageBitmap(bitmap1)
                    BitMapToString(bitmap1)

                    val path = (Environment
                        .getExternalStorageDirectory()
                        .toString() + File.separator
                            + "Phoenix" + File.separator + "default")
                    f.delete()
                    var outFile: OutputStream? = null
                    val file = File(path, System.currentTimeMillis().toString() + ".jpg")
                    img = file.name
                    try {
                        outFile = FileOutputStream(file)
                        bitmap1.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        outFile.flush()
                        outFile.close()
                    } catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }else if (requestCode == 2) {
                val selectedImage = data?.data
                val filePathColumn = arrayOf(MediaStore.Images.Media.DATA)
                val cursor: Cursor? = contentResolver.query(
                    selectedImage!!,
                    filePathColumn, null, null, null
                )
                cursor?.moveToFirst()
                val columnIndex: Int = cursor!!.getColumnIndex(filePathColumn[0])
                val picturePath: String = cursor.getString(columnIndex)
                val imgNama = File(picturePath)
                try {
                    bitmap1 = MediaStore.Images.Media.getBitmap(contentResolver, selectedImage)
                    bitmap1 = getResizedBitmap(bitmap1, 400)
                    binding.imgSolarTerakhir.setImageBitmap(bitmap1)
                    binding.btnSolarTerakhir.text = imgNama.name.toString().toEditable()
                    img = imgNama.name
                    var outFile: OutputStream? = null
                    try{
                        outFile = FileOutputStream(imgNama)
                        bitmap1.compress(Bitmap.CompressFormat.JPEG, 100, outFile)
                        outFile.flush()
                        outFile.close()

                    }catch (e: FileNotFoundException) {
                        e.printStackTrace()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }

                } catch (e: IOException) {
                    e.printStackTrace()
                }

            }
        }
    }



    fun BitMapToString(userImage1: Bitmap): String? {
        val baos = ByteArrayOutputStream()
        userImage1.compress(Bitmap.CompressFormat.PNG, 60, baos)
        val b = baos.toByteArray()
        Document_img1 = Base64.encodeToString(b, Base64.DEFAULT)
        return Document_img1
    }
    fun getResizedBitmap(image: Bitmap, maxSize: Int): Bitmap {
        var width = image.width
        var height = image.height
        val bitmapRatio = width.toFloat() / height.toFloat()
        if (bitmapRatio > 1) {
            width = maxSize
            height = (width / bitmapRatio).toInt()
        } else {
            height = maxSize
            width = (height * bitmapRatio).toInt()
        }
        return Bitmap.createScaledBitmap(image, width, height, true)
    }

    fun String.toEditable(): Editable =  Editable.Factory.getInstance().newEditable(this)

    fun createTempFile(bitmap: Bitmap):File{
        var file  = File(getExternalFilesDir(Environment.DIRECTORY_PICTURES),
            System.currentTimeMillis().toString()+"_image.PNG")
        var bos = ByteArrayOutputStream()

        bitmap.compress(Bitmap.CompressFormat.PNG,0, bos)
        var bitmapData = bos.toByteArray()

        try {
            var fos =  FileOutputStream(file)
            fos.write(bitmapData)
            fos.flush()
            fos.close()
        } catch (e:IOException) {
            e.printStackTrace()
        }
        return file;

        println(file.toString())
    }

    @NonNull
    fun createFormatString(descriptionString:String):RequestBody  {
        return RequestBody.create(
            MultipartBody.FORM, descriptionString);
    }

    override fun onSupportNavigateUp():Boolean{
        onBackPressed()
        return true
    }
}