package com.sibatel.solarapp.ui.user

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Toast
import androidx.fragment.app.Fragment
import androidx.lifecycle.Observer
import androidx.lifecycle.ViewModelProvider
import com.sibatel.solarapp.adapter.UserAdapter
import com.sibatel.solarapp.data.model.user.User
import com.sibatel.solarapp.data.viewmodel.UserViewModel
import com.sibatel.solarapp.databinding.FragmentProfilBinding
import com.sibatel.solarapp.utils.ViewModelFactory

class ProfilKoordinatorFragmend : Fragment(){

    private lateinit var fragmentBinding : FragmentProfilBinding

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        fragmentBinding = FragmentProfilBinding.inflate(inflater, container, false)
        return fragmentBinding.root
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        if (activity!=null){
            val factory = ViewModelFactory.getInstance()
            val viewModelCatalog = ViewModelProvider(
                this, factory
            )[UserViewModel::class.java]

            val profilSCD = ArrayList<User>()
            showLoading(true)

            viewModelCatalog.getUser().observe(viewLifecycleOwner, Observer {
                if (it.isEmpty()){
                    Toast.makeText(context, "Data Kosong", Toast.LENGTH_LONG).show()
                }else{
                    it.forEach{
                        if (it.role.equals("koordinator")){
                            profilSCD.add(it)
                        }
                    }
                    showDataScd(profilSCD)
                    showLoading(false)
                }
            })

        }

    }

    fun showDataScd(listSCD : ArrayList<User>){
        fragmentBinding.rvProfil.adapter = UserAdapter(listSCD)
    }

    private fun showLoading(state: Boolean) {
        if (state)
            fragmentBinding.progress.visibility = View.VISIBLE
        else
            fragmentBinding.progress.visibility = View.GONE
    }
}